#

API Docs for: 0.3.35
Show: Inherited Protected Private Deprecated

# YUIDoc Class

Defined in: `lib/yuidoc.js:50`
Module: yuidoc

YUIDoc main class

       var options = {
           paths: [ './lib' ],
           outdir: './out'
       };

       var Y = require('yuidoc');
       var json = (new Y.YUIDoc(options)).run();

## Constructor

### `YUIDoc`

(

- `config`

)

Defined in `lib/yuidoc.js:50`

#### Parameters:

- `config` Object

  The config object

- Index
- Methods
- Properties

## Item Index

### Methods

- _processConfig
- _setDefaultExcludes
- parsedir
- parsefiles
- run
- walk
- writeJSON

### Properties

- dirmap
- endtime
- filecount
- filemap
- OPTIONS
- options
- selleck
- starttime

## Methods

### `_processConfig`

() private

Defined in `lib/yuidoc.js:127`

Does post process on self.options.

### `_setDefaultExcludes`

() private

Defined in `lib/yuidoc.js:113`

Always exclude these directories

### `parsedir`

(

- `dir`

)
private

Defined in `lib/yuidoc.js:147`

Walks the passed directory and grabs all the files recursively.

#### Parameters:

- `dir` String

  The directory to parse the contents of.

### `parsefiles`

(

- `dir`
- `files`

)
private

Defined in `lib/yuidoc.js:182`

Gathers all the file data and populates the filemap and dirmap hashes.

#### Parameters:

- `dir` String

  The directory to start from.

- `files` Array

  List of files to parse.

### `run`

() Object

Defined in `lib/yuidoc.js:311`

Process the config, walk the file tree and write out the JSON data.

#### Returns:

Object: The JSON data returned from the DocParser

### `walk`

() private

Defined in `lib/yuidoc.js:137`

Walks the paths and parses the directory contents

### `writeJSON`

(

- `parser`

)
Object private

Defined in `lib/yuidoc.js:233`

Writes the parser JSON data to disk.

#### Parameters:

- `parser` Object

  The DocParser instance to use

#### Returns:

Object: The JSON data returned from the DocParser

## Properties

### `dirmap`

Object private

Defined in `lib/yuidoc.js:88`

Holder for the list of directories we are processing.

### `endtime`

Timestamp

Defined in `lib/yuidoc.js:340`

Timestamp holder so we know when YUIDoc has finished the parse process.

### `filecount`

Boolean private

Defined in `lib/yuidoc.js:67`

Holds the number of files that we are processing.

### `filemap`

Object private

Defined in `lib/yuidoc.js:81`

Holder for the list of files we are processing.

### `OPTIONS`

Object final

Defined in `lib/yuidoc.js:29`

The default list of configuration options

### `options`

Object private

Defined in `lib/yuidoc.js:96`

Internal holder for configuration options.

### `selleck`

Object private

Defined in `lib/yuidoc.js:74`

Hash map of dirnames to selleck config options.

### `starttime`

Timestamp

Defined in `lib/yuidoc.js:317`

Timestamp holder so we know when YUIDoc started the parse process.